HOST = "47.75.4.252"
PORT = 10003

menu = 'Welcome to Sixstars Secret Storage Service\nCommands:\n\tset [key]\tstore a secret with given key\n\tget [key]\tget a secret with given key\n'

from pwn import *
import string

def solve_PoW(suffix, h):
    print "solving PoW......"
    charset = string.letters + string.digits

    for p1 in charset:
        for p2 in charset:
            for p3 in charset:
                for p4 in charset:
                    plaintext = p1 + p2+ p3+ p4 + suffix
                    m = hashlib.sha256()
                    m.update(plaintext)
                    if m.hexdigest() == h:
                        print "PoW solution has been found!"
                        return p1+p2+p3+p4 


def encrypt(msg):
    global keystream
    keystream = keystream[16:]
    
    plain = pad(msg)
    assert(len(keystream) >= len(plain))
    k = keystream[:len(plain)]
    
    return xor(plain, k)
    
def decrypt(cipher):
    global keystream
    keystream = keystream[16:]
    assert(len(keystream) >= len(cipher))
    
    k = keystream[:len(cipher)]
    plain = xor(cipher, k)
    msg = plain[:-ord(plain[-1])] #remove padding from message
    return msg

def pad(msg):
    pad = 16 - len(msg)%16
    plain = msg + chr(pad)*pad
    return plain


def solve_captcha(r):
    captcha = decrypt(r.recv()).strip()[:-2]
    a,b = map(int,captcha.split("+"))
    r.send(encrypt("\x02"+str(a+b)))


def get_keystream_blocks_left():
    global keystream
    return len(keystream)/16-1

def connect_and_init():
    global data_
    
    r = remote(HOST, PORT) 
    data = r.recvuntil("Give me XXXX:")
    suffix = re.findall(r"XXXX\+([^\)]+)",data)[0]
    h = re.findall(r"== ([0-9a-f]+)",data)[0]
    p = solve_PoW(suffix, h)

    r.send(p)
    
    r.send("\x00"+"a"*16)
    data_ = r.recv()[1:]
    r.send("\x01"+data_)
    r.recv()
    
    return r


def get_first_keystrem_part():
    global keystream
    global KEYSTREAM
     
    r = connect_and_init()

    #get first portion of KEYSTREAM
    data = r.recv()
    known_plaintext = pad("\x02" + menu)
    keystream = KEYSTREAM = xor(known_plaintext, data)

    #get one block more
    r.send(encrypt("\x01"+data_))
    r.recv()
    d = r.recv()
    KEYSTREAM += xor(known_plaintext, d)[-16:]
    keystream = KEYSTREAM[16:]

    r.close()

def get_new_keystream_a():
    global KEYSTREAM
    global keystream
    
    r = connect_and_init()
    data = r.recv() #this is the first part of keystream

    keystream = KEYSTREAM

    while get_keystream_blocks_left()!=1:
        r.send(encrypt("\x02bad"))
        decrypt(r.recv()) #\x02invalid

    r.send(encrypt("\x02bad"))
    ciphertext = r.recv()
    KEYSTREAM += xor(ciphertext, pad("\x02invalid"))
    r.close()


def get_new_keystream_b():
    global KEYSTREAM
    global keystream

    r = connect_and_init()
    data = r.recv() #this is the first part of keystream
    keystream = KEYSTREAM
    r.send(encrypt("\x01"+data_))
    r.recv()
    r.recv()

    keystream = KEYSTREAM[16:]
    while get_keystream_blocks_left()!=1:
        r.send(encrypt("\x02bad"))
        decrypt(r.recv()) #\x02invalid


    r.send(encrypt("\x02bad"))
    ciphertext = r.recv()
    KEYSTREAM += xor(ciphertext, pad("\x02invalid"))

    r.close()

def get_flag():
    global KEYSTREAM
    global keystream
    
    #last phase - get flag!!
    r = connect_and_init()
    data = r.recv()
    keystream = KEYSTREAM
    r.send(encrypt("\x02get flag"))
    for i in range(12):
        solve_captcha(r)
    
    print decrypt(r.recv())

get_first_keystrem_part()
for i in range(15):
    get_new_keystream_a()
    get_new_keystream_b()
get_flag()

 
